// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	v1beta1 "github.com/tg123/sshpiper/plugin/kubernetes/apis/sshpiper/v1beta1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakePipes implements PipeInterface
type FakePipes struct {
	Fake *FakeSshpiperV1beta1
	ns   string
}

var pipesResource = schema.GroupVersionResource{Group: "sshpiper", Version: "v1beta1", Resource: "pipes"}

var pipesKind = schema.GroupVersionKind{Group: "sshpiper", Version: "v1beta1", Kind: "Pipe"}

// Get takes name of the pipe, and returns the corresponding pipe object, and an error if there is any.
func (c *FakePipes) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1beta1.Pipe, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(pipesResource, c.ns, name), &v1beta1.Pipe{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.Pipe), err
}

// List takes label and field selectors, and returns the list of Pipes that match those selectors.
func (c *FakePipes) List(ctx context.Context, opts v1.ListOptions) (result *v1beta1.PipeList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(pipesResource, pipesKind, c.ns, opts), &v1beta1.PipeList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1beta1.PipeList{ListMeta: obj.(*v1beta1.PipeList).ListMeta}
	for _, item := range obj.(*v1beta1.PipeList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested pipes.
func (c *FakePipes) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(pipesResource, c.ns, opts))

}

// Create takes the representation of a pipe and creates it.  Returns the server's representation of the pipe, and an error, if there is any.
func (c *FakePipes) Create(ctx context.Context, pipe *v1beta1.Pipe, opts v1.CreateOptions) (result *v1beta1.Pipe, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(pipesResource, c.ns, pipe), &v1beta1.Pipe{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.Pipe), err
}

// Update takes the representation of a pipe and updates it. Returns the server's representation of the pipe, and an error, if there is any.
func (c *FakePipes) Update(ctx context.Context, pipe *v1beta1.Pipe, opts v1.UpdateOptions) (result *v1beta1.Pipe, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(pipesResource, c.ns, pipe), &v1beta1.Pipe{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.Pipe), err
}

// Delete takes name of the pipe and deletes it. Returns an error if one occurs.
func (c *FakePipes) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteActionWithOptions(pipesResource, c.ns, name, opts), &v1beta1.Pipe{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakePipes) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(pipesResource, c.ns, listOpts)

	_, err := c.Fake.Invokes(action, &v1beta1.PipeList{})
	return err
}

// Patch applies the patch and returns the patched pipe.
func (c *FakePipes) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1beta1.Pipe, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(pipesResource, c.ns, name, pt, data, subresources...), &v1beta1.Pipe{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.Pipe), err
}
